local addonName, player = ...

local TRADEFILL = LibStub("AceAddon-3.0"):GetAddon(addonName)

player.signature = "|c8788EEff" .. addonName .. ":|r "

function TRADEFILL:TRADE_SHOW()
    local receiverName, _ = UnitName("npc")
    local className, classFile, _ = UnitClass("npc")

    player.name = receiverName
    player.level = UnitLevel("npc")
    player.guild = GetGuildInfo("npc")
    player.class = { ["name"] = className, ["file"] = classFile }
    player.item = { ["a"] = getItem(player.data.item.a.id), ["b"] = getItem(player.data.item.b.id) }

    player.stack = TRADEFILL.db.profile.stacks[classFile]

    self:RegisterEvent("TRADE_CLOSED")
    self:RegisterEvent("UI_INFO_MESSAGE")
    self:RegisterEvent("BAG_UPDATE_DELAYED")
    self:RegisterEvent("SECURE_TRANSFER_CANCEL")

    searchInventory()

    local group = groupCondition()

    local stranger = TRADEFILL.db.profile.setting.solo
    local party = TRADEFILL.db.profile.setting.party
    local raid = TRADEFILL.db.profile.setting.raid

    if (stranger == true and group.status == "solo") then

        if tradingCondition() then
            return
        end

        if player.item.a.id > 0 and player.stack.a > 0 then
            ItemCondition(player.stack.a, player.item.a)
        end

        if player.item.b.id > 0 and player.stack.b > 0 then
            ItemCondition(player.stack.b, player.item.b)
        end
        return
    end

    if (party == true and group.status == "party") or (raid == true and group.status == "raid") then

        if tradingCondition() then
            return
        end

        local numGroupMembers = GetNumGroupMembers()

        if numGroupMembers > 0 then
            for i = 1, numGroupMembers do
                local unitName, _ = UnitName(group.status .. i)

                if unitName == player.name then

                    if player.item.a.id > 0 and player.stack.a > 0 then
                        ItemCondition(player.stack.a, player.item.a)
                    end

                    if player.item.b.id > 0 and player.stack.b > 0 then
                        ItemCondition(player.stack.b, player.item.b)
                    end
                    break
                end
            end
        end
    end
end

function TRADEFILL:UI_INFO_MESSAGE(event, index, info)
    if info == 	"Trade complete."  then
        showMessage(player.signature .. "Trading |cFF00FF00complete|r with " .. getName() )
    end

    if info == "Trade cancelled." then
        showMessage(player.signature .. "Trading |cFFFF0000cancelled|r with " .. getName() )
    end
end

function TRADEFILL:BAG_UPDATE_DELAYED()
    clearTade()

    TRADEFILL:TRADE_SHOW()
end

function TRADEFILL:SECURE_TRANSFER_CANCEL()
    searchInventory()
end

function TRADEFILL:TRADE_CLOSED()
    messageAppear = {}

    TRADEFILL:UnregisterEvent("BAG_UPDATE_DELAYED")
    TRADEFILL:UnregisterEvent("SECURE_TRANSFER_CANCEL")
end