local addonName, player = ...

function getItem(id)
    local itemName, itemLink, _, _, itemMinLevel, _, _, itemStackCount, _, iconTexture = GetItemInfo(id)

    return { ["id"] = id, ["name"] = itemName, ["link"] = itemLink, ["level"] = itemMinLevel, ["stack"] = itemStackCount, ["icon"] = iconTexture }
end

function clearTade()
    for i = 1, MAX_TRADABLE_ITEMS do
        ClearCursor()
        ClickTradeButton(i)
    end
    ClearCursor()
    availableItems()
end

function tradePosition()
    for i = 1, MAX_TRADABLE_ITEMS do
        if GetTradePlayerItemLink(i) == nil then
            return i
        end
    end
end

function groupCondition()
    if IsInRaid() then
        return { ["status"] = "raid" }
    elseif IsInGroup() then
        return { ["status"] = "party" }
    else
        return { ["status"] = "solo" }
    end
end


function getName()
    local class = player.class.file
    local _, _, _, argbHex = GetClassColor(class)

    if class == "SHAMAN" then
        argbHex = "FF0070DE"
    end

    return "|c".. argbHex .. player.name .. "|r"
end

function setName(name, class)
    local _, _, _, argbHex = GetClassColor(class)

    if class == "SHAMAN" then
        argbHex = "FF0070DE"
    end

    return "|c".. argbHex .. name .. "|r"
end

function setClassName(class)
    local _, _, _, argbHex = GetClassColor(class)

    if class == "SHAMAN" then
        argbHex = "FF0070DE"
    end

    if class == "DEATHKNIGHT" then
        return "|c".. argbHex .. "Death Knight|r"
    elseif class == "DEATHKNIGHT" or class == "DEMONHUNTER" then
        return "|c".. argbHex .. "Demon Hunter|r"
    else
         return "|c".. argbHex .. class:sub(1, 1):upper() .. class:sub(2):lower() .. "|r"
    end
end